const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const messages = sequelize.define(
    'messages',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

message_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"text",


"image",


"file",


"product_card",


"order_card",


"payment_request",


"system"

        ],

      },

text_body: {
        type: DataTypes.TEXT,
      
      

      },

link_url: {
        type: DataTypes.TEXT,
      
      

      },

sent_at: {
        type: DataTypes.DATE,
      
      

      },

read_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  messages.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity












































//end loop



    db.messages.belongsTo(db.chats, {
      as: 'chat',
      foreignKey: {
        name: 'chatId',
      },
      constraints: false,
    });

    db.messages.belongsTo(db.users, {
      as: 'sender',
      foreignKey: {
        name: 'senderId',
      },
      constraints: false,
    });

    db.messages.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });



    db.messages.hasMany(db.file, {
      as: 'image_attachments',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.messages.getTableName(),
        belongsToColumn: 'image_attachments',
      },
    });

    db.messages.hasMany(db.file, {
      as: 'file_attachments',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.messages.getTableName(),
        belongsToColumn: 'file_attachments',
      },
    });


    db.messages.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.messages.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return messages;
};


